### Virtual Method

# Gio OutputStream write_fn

#### Declaration

    gssize
    write_fn (
      GOutputStream* stream,
      void* buffer,
      gsize count,
      GCancellable* cancellable,
      GError** error
    )

#### Description

Tries to write `count` bytes from `buffer` into the stream. Will block during the operation.

If count is 0, returns 0 and does nothing. A value of `count` larger than `G_MAXSSIZE` will cause a `G_IO_ERROR_INVALID_ARGUMENT` error.

On success, the number of bytes written to the stream is returned. It is not an error if this is not the same as the requested size, as it can happen e.g. on a partial I/O error, or if there is not enough storage in the stream. All writes block until at least one byte is written or an error occurs; 0 is never returned (unless `count` is 0).

If `cancellable` is not `NULL`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned. If an operation was partially finished when the operation was cancelled the partial result will be returned, without an error.

On error -1 is returned and `error` is set accordingly.

#### Parameters

`buffer`

  Type: An array of `guint8`

  The buffer containing the data to write.

  The argument can be `NULL`.
  The length of the array is specified in the `count` argument.
  The data is owned by the caller of the function.

`count`

  Type: `gsize`

  The number of bytes to write.

`cancellable`

  Type: `GCancellable`

  Optional cancellable object.

  The argument can be `NULL`.
  The data is owned by the caller of the function.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the virtual function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gssize`

Number of bytes written, or -1 on error.